import es, string, vecmath, playerlib, gamethread, random, gamethread

# Weapons that have a Nade Launcher attached.
nl_guns = es.ServerVar("nl_guns", "ak47,m4a1,sg552,aug")

# Magnitude of explosions.
nl_magnitude = es.ServerVar("nl_magnitude", 150)

# Radius of explosions.
nl_radius = es.ServerVar("nl_radius", 300)

# Fuse time of grenades.
nl_fuse = es.ServerVar("nl_fuse", 1)

# Speed of the grenades.
nl_speed = es.ServerVar("nl_speed", 60)

# Type of ammo. 1 = Hegrenade slot. 2 = Predefined ammo.
nl_type = es.ServerVar("nl_type", 1)

# Predefined ammo, refilled each round. 0 = Unlimited.
nl_maxammo = es.ServerVar("nl_maxammo", 3)

es.ServerVar("nadelauncher_ver", "1.0", "The version of NadeLauncher you are running.").makepublic()

def load():
    global nl_players
    nl_players = {}
    for nl_userid in playerlib.getPlayerList('#all'):
        setup(int(nl_userid))
    es.regclientcmd("+attack3", "nadelauncher/fire", "Fire!")
    es.regclientcmd("-attack3")

def unload():
    es.unregclientcmd("+attack3")
    es.unregclientcmd("-attack3")
    for nl_userid in playerlib.getPlayerList('#all'):
        gamethread.cancelDelayed("grenade_%d" % int(nl_userid))
        gamethread.cancelDelayed("ready_%d" % int(nl_userid))

def player_activate(event_var):
    setup(event_var["userid"])

def setup(nl_userid):
    global nl_players
    if not "player_%d" % int(nl_userid) in nl_players:
        nl_players["player_%d" % int(nl_userid)] = {}
        nl_players["player_" + str(nl_userid)]["READY"] = 1
        nl_players["player_" + str(nl_userid)]["FIRED"] = 0
        nl_players["player_" + str(nl_userid)]["GUN"] = 0
        if nl_maxammo != 0:
            nl_players["player_" + str(nl_userid)]["AMMO"] = nl_maxammo
        else:
            nl_players["player_" + str(nl_userid)]["AMMO"] = "UNLIMITED"
    else:
        if nl_maxammo != 0:
            nl_players["player_" + str(nl_userid)]["AMMO"] = nl_maxammo
        else:
            nl_players["player_" + str(nl_userid)]["AMMO"] = "UNLIMITED"

def item_pickup(event_var):
    if event_var["item"] in str(nl_guns):
        if nl_type == 2:
            showammo(event_var["userid"])

def fire():
    global nl_players
    nl_userid = es.getcmduserid()
    nl_player = playerlib.getPlayer(nl_userid)
    if nl_player != None and nl_player.get("isdead") == 0 and nl_player.get("weapon").replace("weapon_", "") in str(nl_guns):
        if nl_players["player_" + str(nl_userid)]["FIRED"] != 0 and nl_player.get('weapon') == nl_players["player_" + str(nl_userid)]["GUN"]:
            nl_entity = nl_players["player_" + str(nl_userid)]["FIRED"]
            gamethread.cancelDelayed("grenade_%s" % nl_userid)
            gamethread.cancelDelayed("ready_%s" % nl_userid)
            gamethread.delayedname(2, "ready_%s" % nl_userid, ready, args=(nl_userid))
            explode(nl_userid, nl_entity)
        else:
            nl_start = 0
            if nl_type == 1:
                if nl_player.get("he") == 1:
                    nl_start = 1
            if nl_type == 2:
                if nl_players["player_" + str(nl_userid)]["AMMO"] >= 1 or nl_players["player_" + str(nl_userid)]["AMMO"] == "UNLIMITED":
                    nl_start = 1
            if nl_start == 1 and nl_players["player_" + str(nl_userid)]["READY"] == 1:
                if nl_type == 2 and nl_players["player_" + str(nl_userid)]["AMMO"] != "UNLIMITED":
                    nl_players["player_" + str(nl_userid)]["AMMO"] -= 1
                else:
                    nl_player.set("he", 0)
                nl_ang = nl_player.get('viewangle')
                es.setang(nl_userid, nl_ang[0] - 15, nl_ang[1], nl_ang[2])
                es.server.cmd("es_prop_physics_create %d weapons/w_eq_fraggrenade.mdl" % int(nl_userid))
                nl_entity = es.ServerVar("eventscripts_lastgive")
                nl_vector1 = es.getplayerprop(nl_userid, "CBaseEntity.m_vecOrigin")
                nl_r = es.getplayerprop(nl_userid, "CBasePlayer.localdata.m_vecViewOffset[0]")
                nl_b = es.getplayerprop(nl_userid, "CBasePlayer.localdata.m_vecViewOffset[1]")
                nl_g = es.getplayerprop(nl_userid, "CBasePlayer.localdata.m_vecViewOffset[2]")
                nl_vector2 = es.createvectorstring(nl_r, nl_b, nl_g)
                nl_vector1 = vecmath.vector(nl_vector1) + vecmath.vector(nl_vector2)
                nl_vector2 = es.getindexprop(nl_entity, "CBaseEntity.m_vecOrigin")
                nl_vector2 = vecmath.vector(nl_vector2) - nl_vector1
                nl_vector2 = vecmath.setlength(nl_vector2, 32)
                nl_vector1 = vecmath.vector(nl_vector1) + vecmath.vector(nl_vector2)
                es.server.cmd("es_delayed 0 es_physics active teleport %d %s" % (nl_entity, nl_vector1))
                nl_vector2 = vecmath.vector(nl_vector2) * nl_speed
                es.server.cmd("es_delayed 0 es_physics active setvelocity %d %s" % (nl_entity, nl_vector2))
                es.emitsound("player", nl_userid, "weapons\grenade_launcher1.wav", 1, 0.75)
                fireinthehole(nl_userid)
                nl_players["player_" + str(nl_userid)]["READY"] = 0
                nl_players["player_" + str(nl_userid)]["FIRED"] = nl_entity
                nl_players["player_" + str(nl_userid)]["GUN"] = nl_player.get('weapon')
                gamethread.delayedname(nl_fuse, "grenade_%s" % nl_userid, explode, args=(nl_userid, nl_entity))
                gamethread.delayedname(nl_fuse + 2, "ready_%s" % nl_userid, ready, args=(nl_userid))
            elif nl_players["player_" + str(nl_userid)]["READY"] == 0:
                es.emitsound("player", nl_userid, "weapons\ClipEmpty_Rifle.wav", 1, 0.75)
            if nl_type == 1 and nl_players["player_" + str(nl_userid)]["READY"] == 1 and nl_player.get("he") == 0:
                es.emitsound("player", nl_userid, "weapons\ClipEmpty_Rifle.wav", 1, 0.75)
            if nl_type == 2 and nl_players["player_" + str(nl_userid)]["READY"] == 1 and nl_players["player_" + str(nl_userid)]["AMMO"] == 0:
                es.emitsound("player", nl_userid, "weapons\ClipEmpty_Rifle.wav", 1, 0.75)
        if nl_type == 2:
            showammo(nl_userid)

def ready(nl_userid):
    global players
    if nl_players != None and nl_userid != None:
        nl_players["player_" + str(nl_userid)]["READY"] = 1

def explode(nl_userid, nl_entity):
    global nl_players
    nl_location = es.getindexprop(nl_entity, "CBaseEntity.m_vecOrigin")
    if nl_userid != None and nl_location != None:
        gamethread.cancelDelayed("followaim_%d" % int(nl_userid))
        nl_playerlib = playerlib.getPlayer(nl_userid)
        nl_primaryammo = nl_playerlib.get("ammo", "1")
        nl_secondaryammo = nl_playerlib.get("ammo", "2")
        nl_primaryclip = nl_playerlib.get("clip", "1")
        nl_secondaryclip = nl_playerlib.get("clip", "2")
        nl_location2 = nl_location.split(",")
        nl_sound = random.randint(3,5)
        es.emitsound("entity", nl_entity, "weapons\explode" + str(nl_sound) + ".wav", 1, 0.60)
        es.remove(nl_entity)
        es.server.cmd("es_give %d env_explosion" % int(nl_userid))
        nl_explosion = es.ServerVar("eventscripts_lastgive")
        es.server.cmd('es_fire %d env_explosion addoutput "origin %s %s %s"' % (int(nl_userid), nl_location2[0], nl_location2[1], nl_location2[2]))
        es.setindexprop(nl_explosion, "CBaseEntity.m_vecOrigin", nl_location)
        es.server.cmd('es_fire %d env_explosion addoutput "imagnitude %d"' % (int(nl_userid), int(nl_magnitude)))
        es.server.cmd('es_fire %d env_explosion addoutput "iradiusoverride %d"' % (int(nl_userid), int(nl_radius)))
        nl_player = es.getplayerhandle(nl_userid)
        es.setindexprop(int(nl_explosion), "CBaseEntity.m_hOwnerEntity", nl_player)
        if es.ServerVar("mp_friendlyfire") == 0:
            nl_team = es.getplayerteam(nl_userid)
            es.setindexprop(int(nl_explosion), "CBaseEntity.m_iTeamNum", nl_team)
        es.server.cmd("es_fire %d env_explosion Explode" % int(nl_userid))
        nl_players["player_" + str(nl_userid)]["FIRED"] = 0
        nl_playerlib.set("ammo", ("1", nl_primaryammo))
        nl_playerlib.set("ammo", ("2", nl_secondaryammo))
        nl_playerlib.set("clip", ("1", nl_primaryclip))
        nl_playerlib.set("clip", ("2", nl_secondaryclip))

def fireinthehole(nl_userid):
    nl_player = playerlib.getPlayer(nl_userid)
    nl_name = nl_player.attributes['name']
    nl_index = nl_player.attributes['index']
    nl_text = "\1\3%s\1 (RADIO): Fire in the hole!" % nl_name
    es.usermsg('create','fith','SayText2')
    es.usermsg('write','byte','fith',nl_index)
    es.usermsg('write','byte','fith',True)
    es.usermsg('write','string','fith',nl_text)
    es.usermsg('write','string','fith','')
    es.usermsg('write','string','fith','')
    es.usermsg('write','string','fith','')
    es.usermsg('write','string','fith','')
    if nl_player.get('teamid') == 2:
        for nl_userid in playerlib.getPlayerList('#t'):
            es.usermsg('send','fith',int(nl_userid))
            es.playsound(int(nl_userid), "radio\ct_fireinhole.wav", 1)
    if nl_player.get('teamid') == 3:
        for nl_userid in playerlib.getPlayerList('#ct'):
            es.usermsg('send','fith',int(nl_userid))
            es.playsound(int(nl_userid), "radio\ct_fireinhole.wav", 1)
    es.usermsg('delete','fith')

def round_start(event_var):
    global nl_players
    for nl_userid in playerlib.getPlayerList('#all'):
        gamethread.cancelDelayed("grenade_%d" % int(nl_userid))
        gamethread.cancelDelayed("ready_%d" % int(nl_userid))
        nl_players["player_%d" % int(nl_userid)]["READY"] = 0
        nl_players["player_%d" % int(nl_userid)]["FIRED"] = 0
        nl_players["player_%d" % int(nl_userid)]["GUN"] = 0
        if nl_maxammo != 0:
            nl_players["player_%d" % int(nl_userid)]["AMMO"] = nl_maxammo
        else:
            nl_players["player_%d" % int(nl_userid)]["AMMO"] = "UNLIMITED"
        gamethread.delayedname(es.ServerVar("mp_freezetime"), "ready_%d" % int(nl_userid), ready, args=(int(nl_userid)))
    es.msg("#multi", "#green[NadeLauncher] #defaultYou can launch a grenade from the front of certain rifles!")

def showammo(nl_userid):
    nl_ammo = nl_players["player_" + str(nl_userid)]["AMMO"]
    es.usermsg('create','hudhint','HintText')
    es.usermsg('write','short','hudhint',-1)
    es.usermsg('write','string','hudhint',"Grenades: %s" % nl_ammo)
    es.usermsg('send','hudhint',nl_userid)
    es.usermsg('delete','hudhint')